unit Timefrm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Timers, Buttons;

type
  TTimerPoolDemoForm = class(TForm)
    OneShotTimer: TOneShotTimer;
    IntervalTimer: TIntervalTimer;
    DelayTimer: TDelayTimer;
    OneShotList: TListBox;
    IntervalList: TListBox;
    DelayList: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    RestartButton: TButton;
    procedure OneShotTimerTimer(Sender: TObject);
    procedure IntervalTimerTimer(Sender: TObject);
    procedure DelayTimerTimer(Sender: TObject);
    procedure RestartButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TimerPoolDemoForm: TTimerPoolDemoForm;

implementation

{$R *.DFM}

procedure TTimerPoolDemoForm.OneShotTimerTimer(Sender: TObject);
begin
  { A one shot timer is only excuted once. }
  OneShotList.Items.Add( TimeToStr(Now) +
    Format( ' (%d ms)', [GetTickCount-OneShotList.Tag]));
end;

procedure TTimerPoolDemoForm.IntervalTimerTimer(Sender: TObject);
var I,A,B: LongInt;
begin
  { An interval timer restarts the timer before the timer event is handled. }
  { pro : period is constant. }
  { con : reentrance is possible. }

  IntervalList.Items.Add( TimeToStr(Now) +
    Format( ' (%d ms)', [GetTickCount-IntervalList.Tag]));
  IntervalList.Tag := GetTickCount;

  { waist some time }
  for I := 0 to LongInt(1000)*Random(1000) do GetTickCount;
end;

procedure TTimerPoolDemoForm.DelayTimerTimer(Sender: TObject);
var I: LongInt;
begin
  { A delay timer restarts the timer after the timer event is handled. }
  { pro : reentrance not possible. }
  { con : period is not constant. }

  DelayList.Items.Add( TimeToStr(Now) +
    Format( ' (%d ms)', [GetTickCount-DelayList.Tag]));
  DelayList.Tag := GetTickCount;

  { waist some time }
  for I := 0 to LongInt(1000)*Random(1000) do GetTickCount;
end;

procedure TTimerPoolDemoForm.RestartButtonClick(Sender: TObject);
begin
  OneShotTimer.Enabled := False;
  IntervalTimer.Enabled := False;
  DelayTimer.Enabled := False;

  OneShotList.Items.Clear;
  IntervalList.Items.Clear;
  DelayList.Items.Clear;
  OneShotList.Tag := GetTickCount;
  IntervalList.Tag := GetTickCount;
  DelayList.Tag := GetTickCount;

  OneShotTimer.Enabled := True;
  IntervalTimer.Enabled := True;
  DelayTimer.Enabled := True;
end;

end.
